/*	:
	:		ucompack.cv  ` command pack utility `
	:													by  Shinki.
	:					1991.11.09			1st version
	:			 char = unsigned char
*/

#include	<string.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<memory.h>
#include	<ctype.h>

#define		LIST		0
#define		DELETE		1
#define		ADD			2
#define		RENAME		3

/*
#define		debug
*/
#define		LEN			602
#define		MAX_LEN		0x5fff		/*  őx[Xt@C  */

extern	char	basefile[LEN];

		char	base_id[]=
					 {  0xeb,0x35,0x43,0x4f,0x4d,0x50,0x41,0x43,0x4b };

void	main( int argc,char *argv[] );
void	help( void );
void	job( char *file1,char *file2,int mode );
size_t	GetFileLength( char *name );
void	error( char *msg1,char *msg2 );

void	main( int argc,char *argv[] )
{	char	*s;
	int				mode;
	char	file1[128],file2[128];
	int				i,n;

/*  ϐ  */
	mode=ADD;
	strcpy( file1,"" );
	strcpy( file2,"" );

	for( i=1;i<argc;i++ )
	{	s=argv[i];
		if( *s=='-' || *s=='/' || *s=='^' )
		{	switch( *(++s) )
			{
/*				case 'd':	case 'D':
					mode=DELETE;
					break;
*/				case 'L':	case 'l':
					mode=LIST;
					break;
				case 'A':	case 'a':
					mode=ADD;
					break;
				case 'H':	case 'h':	case '?':		/*  help  */
					help();		/*  and exit  */
				default:
					printf( "@ IvVwG[!!  ('%c')\n\n",*s );
					exit( 1 );
			}
		}
	}

	n=0;
	for( i=1;i<argc;i++ )
	{	s=argv[i];
		if( *s=='-' || *s=='/' || *s=='^' )
			continue;

		if( (n++)==0 )
		{	strcpy( file1,s );
			if( (s=strrchr( file1,'.' ))!=NULL )
				*s='\0';
			strcat( file1,".com" );
		}
		else
		{	strcpy( file2,s );
			if( (s=strrchr( file2,'.' ))!=NULL )
				*s='\0';
			strcat( file2,".com" );
			if( mode!=LIST )
				job( file1,file2,mode );	/*  add/delete [h  */
		}
	}
	if( file1[0]!='\0' && file2[0]=='\0' )
		mode=LIST;				/*  ް̧ق̂ݎw莞́ALISTw  */
	if( file1[0]=='\0' )
		help();					/*  ްَ̧w薳ꍇ́AHELP & EXIT  */
	if( mode==LIST )
		job( file1,"",mode );	/*  LIST [h  */
}

size_t	GetFileLength( char *name )		/*  ==0.....errror  */
{	FILE	*fd;
	size_t	len;

	if ( (fd=fopen( name,"rb" ))==NULL )
		return( 0 );
	fseek( fd,0,SEEK_END );
	len=(size_t)ftell( fd );
	if ( fclose( fd )==EOF )
		error( "file close","get_file_length" );
	return( len );
}

void	error( char *msg1,char *msg2 )
{	printf( "@System error : '%s'   in function:u%sv\n",msg1,msg2 );
	printf( "program aborted!!\n\n" );
	exit( 2 );
}

void	help( void )
{	printf( "@gelp lessage for ComPack v1.00  By Shinki.  \n"
			"\n    ComPack : COMt@CЂƂ܂Ƃ߂ɂ\n"
			"        : ComPack [-/Option] ް̧ [ޯ̧1"
														" [ޯ2 ]]\n" );
	printf( "    Option  : '?' or 'H' .... wvbZ[W\(̉)\n"
			"            : 'a'        .... x[Xt@CɃ^[Qbgt@C"
															"܂\n" );
	printf( "            : 'l'        .... x[Xt@C̒g𒲂ׂ\n" );
/*
			"            : 'd'        .... x[Xt@C^[Qbgt@C"
															"폜\n\n" );
*/
	printf( "    Ex.     : compack all prog1  ... all.com  prog1 ǉ\n" );
	printf( "            : compack all        ... all.com ̒g{\n\n" );
	exit( 0 );
}

void	job( char *file1,char *file2,int mode )
{	FILE			*fp1;
	size_t			len1,len2;
	char	buff[MAX_LEN];
	char	temp[128];					/*  ǉW[Fmp  */
	unsigned int	pointer;
	char	*s;
	char	c;
	unsigned int	address;
	unsigned int	write_size;					/*  ݃TCY  */
	int				nn,n;						/*  AvO  */
	int				i;							/*  [vJE^  */

	len1=GetFileLength( file1 );

	if( len1>MAX_LEN )							/*  傫ꍇ  */
	{	printf( "@ ȏ۸тǉł܂\n" );
		goto	end;
	}
	if( len1==0 )
	{	memcpy( buff,basefile,LEN );			/*  VK쐬  */
		len1=LEN;
	}
	else
	{	if( (fp1=fopen( file1,"rb" ))==NULL )
			error( "file open","job" );
		if( fread( buff,1,(size_t)len1,fp1 )<len1 )
			error( "file read","job" );
		if( fclose( fp1 )==EOF )
			error( "file close","job" );
		for( i=0;i<8;i++ )				/*  x[Xt@Ĉhc`FbN  */
		{	if( base_id[i]!=buff[i] )
			{	printf( "@ x[Xt@Cُł\n" );
				exit( 1 );
			}
		}
	}

	pointer=(buff[10]-1)*256+buff[9];		/*  headerʒuփXgA  */
	nn=n=buff[pointer];

#ifdef	debug
	printf( "wb_ʒu.......0x%04X\n",pointer );
	printf( "AvO......%d\n",n );
	printf( "buff[ 9].......%d\n",buff[9] );
	printf( "buff[10].......%d\n",buff[10] );
#endif

	switch( mode )
	{	case	ADD:
			printf( "u%svɁu%svǉ܂\n",file1,file2 );
			if( (len2=GetFileLength( file2 ))==0 )
			{	printf( "\x07		\x1b[31mt@C܂\x1b[m\n"
																	,file2 );
				goto	end;
			}


#ifdef	debug
	printf( "length1.....%d  /  length2.....%d\n",len1,len2 );
#endif

			if( (write_size=len1+len2+0x10)>=MAX_LEN )
			{	printf( "\x07		\x1b[31mȏǉł܂\x1b[m\n" );
				goto	end;
			}

			buff[pointer++]++;				/*  A۸ѐ ݸ  */

			while( (n--)>0 )
			{	address=buff[pointer+10]+buff[pointer+11]*256+0x10;
				buff[pointer+10]=address%256;
				buff[pointer+11]=address/256;	/*  i[ʒuͯޕ׽  */
				pointer+=0x10;					/*  wb_̃XLbv  */
			}

#ifdef	debug
	printf( "(len1-pointer)=%d\n",len1-pointer );
#endif

			if( nn!=0 )
				memmove( &buff[pointer+0x10],&buff[pointer],
												(size_t)(len1-pointer) );

			strcpy( temp,file2 );
			if( (s=strrchr( temp,'.' ))!=NULL )
				*s='\0';
			if( (s=strrchr( temp,'\\' ))==NULL )
				s=temp;
			if( *s=='\\' )
				s++;
			if( *(s+1)==':' )
				s+=2;
			sprintf( &buff[pointer],"%-8s",s );		/*  :W[  */
			for( i=1;i<=8;i++ )
			{	c=buff[pointer];				/*  W[LI  */
				buff[pointer++]=toupper( c );	/*     (Ӽ  )   */
			}
#ifdef	debug
	printf( "write_size ......%d\n",write_size );
	printf( "W[ : '%-8s'\n",s );
#endif

			buff[pointer++]=len2%256;
			buff[pointer++]=len2/256;			/*  W[TCYL  */

			address=len1+0x110;				/*  address:ǋL۸ъi[ʒu  */
			buff[pointer++]=address%256;
			buff[pointer++]=address/256;		/*  i[ʒűLI  */

			buff[pointer++]=buff[pointer++]=buff[pointer++]=buff[pointer]=0;
												/*  \̈[NA  */

			pointer=len1+0x10;					/*  ǉʒuֈړ  */



			if( (fp1=fopen( file2,"rb" ))==NULL )
				printf( "file open(file2)","job" );
			if( fread( &buff[pointer],1,(size_t)len2,fp1 )<len2 )
				error( "file read","job" );
			if( fclose( fp1 )==EOF )
				error( "file close(file2)","job" );
												/*  ǉӼޭٓǂݍݏI  */

			if( (fp1=fopen( file1,"wb" ))==NULL )
				error( "file open(basefile-write)","job" );

			if( fwrite( buff,1,write_size,fp1 )<write_size )
				error( "file write(basefile-write)","job" );
			if( fclose( fp1 )==EOF )
				error( "file close(basefile-write)","job" );
			break;
		case	LIST:
			printf( "x[Xt@C %s ̈ꗗ\n\n",file1 );
			if( n==0 )
			{	printf( "@ x[Xt@C܂\n" );
				exit( 1 );
			}
			pointer++;
			printf( "  R}h        TCY\n"
					"---------------   -----------\n"
					"bomoack{         $%04x\n",pointer );
			for( ;n>0;n-- )
			{	for( i=1;i<=8;i++ )
					putchar( buff[pointer++] );
				len2=buff[pointer++]+buff[pointer]*256;
				printf( "              $%04x\n",len2 );
				pointer+=7;			/*  \̈XLbv  */
			}
			printf( "---------------   -----------\n"
					"    v              $%04x  (c $%04x ޲)\n"
												,len1,MAX_LEN-len1 );
			break;
	}
end:;
}
